#!/bin/bash

# PT site's RSS checker
# By Bill Haofei Gong on 5th Jan, 2013
#
#     UPDATE 01 on 6th Jan, 2013:
#         Clean up the script, and implemented diff checker to avoid unnecessary download.
#     UPDATE 02 on 8th Jan, 2013:
#         Updated comment and replace useless echos to logger so result will be shown on syslog.
#     UPDATE 03 on 8th Jan, 2013:
#         Added empty RSS check and remove unnecessary comment.

TEMP_FILE_LOCATION="/tmp/rss-checker.tmp"
DESTINATION_DIR="HERE-IS-DESTINATION-FOLDER"
RSS_URI="HERE-IS-RSS-URI"
RSS_PATTERN="rssdd.php"
SED_PATTERN='s/<link>//g;s/<\/link>/,/g'

# Download and parse the RSS from TTG
curl $RSS_URI | grep $RSS_PATTERN | sed $SED_PATTERN > $TEMP_FILE_LOCATION

# Determin if the RSS is empty
if [ -s $TEMP_FILE_LOCATION ]; then
    # Determine if nothing is changed
    if ! diff -q $DESTINATION_DIR/.rss_store $TEMP_FILE_LOCATION; then
        cp -f $TEMP_FILE_LOCATION $DESTINATION_DIR/.rss_store
        wget --content-disposition -i $DESTINATION_DIR/.rss_store --directory-prefix=$DESTINATION_DIR -nc
        logger "RSS-Checker: New torrent is added. "
    fi
fi

# Clean up the temp file
rm -f $TEMP_FILE_LOCATION
